import os, sys
from graph import *

# la liste des graphes crees
graphes = []

# graphes par categorie, pour affichage
graphes_concrets = []
graphes_classiques = []
graphes_complets = []
graphes_bicliques = []
graphes_divers = []
graphes_lineaires = []
graphes_circulaires = []
arbres = []
grilles = []

# graphes dont les aretes ne sont pas nommees 
# si le nom est grxx_... le nombre xx est le nombre de sommets

gr4_1 = make_graph(
    [["S0", "S1"],
     ["S2"],
     ["S1", "S3"]],
    "gr4_1")

gr4_2 = make_graph(
    [
    ["C"],
    ["B","B"],
    ["A","B"],
    ["A","B"],
    ["D","D"],
    ["D","D"]
    ],
    "gr4_2",
    [],
    "rankdir=\"LR\";"
    )

gr4_3cycle = make_graph(
    [["S1","S2"],
     ["S2","S3"],
     ["S3","S4","S1"]],
    "gr4_3cycle")

carre_boucle = make_graph(
    [["A","A","B"],
     ["B","B","C"],
     ["C","C","D"],
     ["D","D","A"]],
    "carre_boucle")

gr5_1= make_graph(
    [["S0","S2","S3"],
     ["S1","S3","S4"],
     ["S2","S3","S4"],
     ["S3","S4"] ],
    "gr5_1"
    )

gr5_2 = make_graph(
    [["S0","S1","S2","S3"],
     ["S1","S3"],
     ["S2","S3"],
     ["S3","S4"]],
    "gr5_2",
    [["S0","red"],
     ["S3","blue"]]
    )

gr6_1 = make_graph([
        ["S5",["S5","e5"],["S2","e3"]],
        ["S2",["S4","e1"],["S3","e4"]],
        ["S3",["S0","e2"],["S4","e6"]],
        ["S4",["S0","e0"]],
        ["S1"]],
                   "gr6_1"
                   )

gr7_1 = make_graph(
    [["S0","S1","S2","S3","S4"],
     ["S6","S1","S2","S3","S4"],
     ["S5","S3","S4"]],
    "gr7_1",
    [["S0","red"]]
    )

gr7_2= make_graph(
    [["S0","S1","S3","S6"],
     ["S1","S3"],
     ["S2","S3","S5"],
     ["S4"],
     ["S5","S6"] ],"gr7_2"
    )

gr8_1fleur = make_graph(
    [["0","1"],
     ["1","2"],
     ["2","3"],
     ["3","4"],
     ["4","0"],
     ["5","5"],
     ["6","7"],
     ["7","6","4"]],
    "gr8_1fleur"
    )

demo_couleurs = make_graph(
    [["blue","cyan","green","magenta","orange"],
     ["yellow","cyan","green","magenta","orange"],
     ["red","magenta","orange"],
     ["white","red","blue"]],
    "demo_couleurs",
    [["blue","blue"],
     ["cyan","cyan"],
     ["green","green"],
     ["magenta","magenta"],
     ["orange","orange"],
     ["red","red"],
     ["yellow","yellow"]]
)

gr9_1 = make_graph(
    [["S3","S1","S6"],
     ["S1","S4","S0"],
     ["S6","S4","S5","S7","S8"],
     ["S0","S2"],
     ["S5","S2"],
     ["S7","S8"]],
    "gr9_1",
    [["S0","red"]]
    )

mode = "ranksep = .2; ratio = 1.5; node[shape=box]; node[style=rounded];"

gr6_3coloriable = make_graph(
    [['a','b','c'],['b','c'],['d','e','f'],['e','f'],['a','d'],['b','e'],['c','f']], "gr6_3coloriable", [], mode)

graphes_divers += [gr6_3coloriable, demo_couleurs, carre_boucle, gr4_3cycle, gr4_2, gr4_1]
graphes_divers += [gr5_1, gr5_2]
graphes_divers += [gr6_1]
graphes_divers += [gr7_1, gr7_2]
graphes_divers += [gr8_1fleur]
graphes_divers += [gr9_1]

graphes += graphes_divers

# arbre n-aire complet, plein, hauteur h
def arbre(n, h, drawopts=""):
    nb_nodes = (n**(h+1)-1)/(n-1)
    l = []
    for i in range(nb_nodes-1):
        l += [[]]
    cpt = 0
    for i in range((n**h-1)/(n-1)):
        for j in range(n):
            l[cpt].append("S" + str(i))
            l[cpt].append("S" + str(n*i+j+1))
            cpt = cpt+1
    return make_graph(l, "arbre"+str(n)+"h"+str(h), [], drawopts)

mode = "ranksep = .2; ratio = .3; node[shape=box]; node[style=rounded];"
arbre2h4 = arbre(2,4, mode)
arbre3h3 = arbre(3,3, mode)
arbre4h2 = arbre(4,2, mode)
arbre9h1 = arbre(9,1, mode)

arbres += [arbre2h4,arbre3h3,arbre4h2,arbre9h1]
graphes_classiques += arbres

# Grilles
def grille (n,m, opt=""):
    l = []
    # les lignes
    for i in range(n):
        for j in range(m):
            if i != n-1:
                l += [["S" + str(m*i+j), "S" + str(m*(i+1)+j)]]
            if j != m-1:
                l += [["S" + str(m*i+j), "S" + str(m*i+j+1)]]
    return make_graph(l, "grille"+str(n)+"x"+str(m), [], opt)

mode = "ranksep = .5; ratio = .7; node[shape=box]; node[style=rounded];"
grille2x3 = grille(2,3, mode)
grille3x3 = grille(3,3, mode)
grille3x4 = grille(3,4, mode)
grille3x5 = grille(3,5, mode)

grilles += [grille2x3, grille3x3, grille3x4, grille3x5]
graphes_classiques += grilles


# Les graphes complets

def k(n) :
    l = []
    for i in range (n) :
        l.append([])
    for i in range (n) :        
        for j in range (i,n) :
            l[i].append("S" + str(j))
    return make_graph(l, "complet"+str(n))

complet2 = k(2)
complet3 = k(3)
complet4 = k(4)
complet5 = k(5)
complet6 = k(6)
complet7 = k(7)

graphes_complets += [complet2,complet3,complet4,complet5,complet6,complet7]

# Les graphes lineaires ( = grille (1,n) )
def lin(n) :
    l = []
    for i in range (n-1) :
        l.append([])
    for i in range (n-1) :        
        l[i].append("S" + str(i))
        l[i].append("S" + str(i+1))
    return make_graph(l, "ligne"+str(n))
        
ligne2 = lin(2)
ligne3 = lin(3)
ligne4 = lin(4)
ligne5 = lin(5)
ligne6 = lin(6)
ligne7 = lin(7)

graphes_lineaires += [ligne2,ligne3,ligne4,ligne5,ligne6,ligne7]
graphes_classiques += graphes_lineaires

# Les graphes circulaires  ( = grillle (2,n) pour les cercles de longueur paire )
def cercle(n) :
    l = []
    for i in range (n) :
        l.append([])
    for i in range (n-1) :        
        l[i].append("S" + str(i))
        l[i].append("S" + str(i+1))
    l[n-1].append("S" + str(n-1))
    l[n-1].append("S0")
    return make_graph(l, "cercle" + str(n))
        
cercle2 = cercle(2)
cercle3 = cercle(3)
cercle4 = cercle(4)
cercle5 = cercle(5)
cercle6 = cercle(6)
cercle7 = cercle(7)

graphes_circulaires += [cercle2,cercle3,cercle4,cercle5,cercle6,cercle7]
graphes_classiques += graphes_circulaires

# Les graphes k(n,m)
def biclique(n,m, opt="") :
    l = []
    for i in range (n*m) :
        l.append([])
    for i in range (n) :
        for j in range (m) :
            l[i*m+j].append("S" + str(i))
            l[i*m+j].append("S" + str(n+j))
    return make_graph(l, "biclique" + str(n) + "_" + str(m), [], opt)

mode = "ranksep = .5; ratio = .7; node[shape=box]; node[style=rounded];"
biclique3_3 = biclique(3,3, mode)
biclique2_4 = biclique(2,4, mode)
biclique3_4 = biclique(3,4, mode)
biclique2_5 = biclique(2,5, mode)
biclique3_5 = biclique(3,5, mode)

graphes_bicliques += [biclique3_3,biclique2_4,biclique3_4,biclique2_5,biclique3_5]
graphes_classiques += graphes_bicliques

Petersen = make_graph(
    [["A", "B", "C", "D", "E"],
     ["1", "3", "5", "2", "4"],
     ["A","1"],
     ["B","2"],
     ["C","3"],
     ["D","4"],
     ["E","5"]
     ],"Petersen")

graphes_classiques += [Petersen]

graphes += graphes_classiques

#graphes "concrets"

Konigsberg = make_graph(
    [
    ["A","B"],
    ["A","B"],
    ["B","C"],
    ["B","C"],
    ["A","D"],
    ["B","D"],
    ["C","D"],
    ],
    "Konigsberg",
    )

# tgv2005_simple = make_graph(
#     [["Lille",
#       ["Paris", ""], ["Nantes", ""], ["Lyon", ""],
#       ["Bordeaux", ""], ["Toulouse", ""],
#       ["Marseille", ""], ["Montpellier", ""]],
#      ["Paris",
#       ["Nantes", ""], ["Lyon", ""], ["Bordeaux", ""],
#       ["Marseille", ""], ["Montpellier", ""],
#       ["Toulouse", ""]],
#      ["Nantes", ["Lyon", ""], ["Marseille", ""]],
#      ["Lyon",
#     ["Toulouse", ""], ["Marseille", ""],
#       ["Montpellier", ""]],
#     ["Bordeaux", ["Toulouse", ""]],
#      ["Toulouse", ["Montpellier", ""]],
#      ["Strasbourg"]],"tgv2005_simple")

tgv2005 = make_graph(
    [["Lille",
      ["Paris", "1h00"], ["Nantes", "4h10"], ["Lyon", "2h50"],
      ["Bordeaux", "5h00"], ["Toulouse", "8h20"],
      ["Marseille", "4h30"], ["Montpellier", "4h40"]],
     ["Paris",
      ["Nantes", "2h00"], ["Lyon", "1h55"], ["Bordeaux", "2h55"],
      ["Marseille", "2h56"], ["Montpellier", "3h15"],
      ["Toulouse", "5h14"]],
     ["Nantes", ["Lyon", "4h20"], ["Marseille", "6h20"]],
     ["Lyon",
    ["Toulouse", "4h30"], ["Marseille", "1h20"],
      ["Montpellier", "1h45"]],
    ["Bordeaux", ["Toulouse", "2h10"]],
     ["Toulouse", ["Montpellier", "2h16"]],
     ["Strasbourg"]],"tgv2005")


Europe = make_graph(
    [
    ["Irlande du Nord","Irlande"],
    ["Angleterre","Pays de Galles", "Ecossse"],
    ["Portugal","Espagne"],
    ["France", "Espagne", "Belgique", "Luxembourg", "Allemagne", "Suisse", "Italie"],
    ["Luxembourg", "Belgique", "Allemagne"],
    ["Belgique", "Allemagne", "Pays Bas"],
    ["Allemagne", "Pays Bas", "Danemark", "Tchequie", "Autriche", "Suisse"],
    ["Autriche", "Tchequie", "Suisse", "Italie", "Slovenie"],
    ["Italie", "Suisse", "Slovenie"],
    ["Slovenie", "Croatie"]
    ],
    "Europe",
    [],
    "rankdir = \"LR\";  ranksep = .2; ratio = .4; node[shape=box]; node[style=rounded];"
    )

tram = make_graph(
    [
# les intersections
    ["Hotel de ville",
     ["Ste Catherine","A"], ["Palais de Justice","A"],
     ["Musee d'Aquitaine","B"], ["Gambetta","B"]],
    ["Quinconces",
     ["Grand Theatre","B"],["CAPC","B"],
     ["Place de la Bourse","C"]],
    ["Porte de Bourgogne",
     ["St Michel","C"], ["Place de la Bourse","C"],
     ["Stalingrad","A"], ["Place du Palais","A"]],

# la ligne C 

    ["St Michel", ["Ste Croix","C"]],
    ["Ste Croix", ["Tauzia","C"]],
    ["Tauzia", ["Gare St Jean","C"]],
# la ligne B
    ["Grand Theatre",["Gambetta","B"]],
    ["CAPC",["Chartrons","B"]],
    ["Chartrons",["Cours du Medoc","B"]],
    ["Cours du Medoc",["Les Hangars","B"]],
    ["Les Hangars",["Bassins a Flot","B"]],
    ["Musee d'Aquitaine", ["Victoire","B"]],
    ["Victoire", ["St Nicolas","B"]],
    ["St Nicolas", ["Bergonie","B"]],
    ["Bergonie", ["Barriere St Genes","B"]],
    ["Barriere St Genes", ["Roustaing","B"]],
    ["Roustaing",["Forum","B"]],
    ["Forum",["Peixotto","B"]],
    ["Peixotto",["Bethanie","B"]],
    ["Bethanie",["Arts et Metiers","B"]],
    ["Arts et Metiers",["Francois Bordes","B"]],
    ["Francois Bordes",["Doyen Brus","B"]],
    ["Doyen Brus",["Montaigne Montesquieu","B"]],
    ["Montaigne Montesquieu",["Unitec","B"]],
    ["Unitec",["Saige","B"]],
    ["Saige",["Bougnard","B"]],
    ["Bougnard",["Camponac Mediatheque","B"]],
    ["Camponac Mediatheque",["Pessac Centre","B"]],
    

# la ligne A
    ["Ste Catherine",["Place du Palais","A"]],
    ["Stalingrad",["Jardin Botanique","A"]],
    ["Jardin Botanique",["Thiers Benauge","A"]],
    ["Thiers Benauge",["Galin","A"]],
    ["Galin",["Jean Jaures","A"]],
    ["Jean Jaures",["Cenon Gare","A"]],
    ["Cenon Gare",["Carnot Mairie de Cenon","A"]],
    ["Carnot Mairie de Cenon",["Butiniere","A"]],
    ["Butiniere",
     ["Palmer","A1"],["Iris","A2"]],

    ["Palais de Justice",["Meriadek","A"]],
    ["Meriadek",["St Bruno Hotel de Region","A"]],
    ["St Bruno Hotel de Region",["Hotel de Police","A"]],
    ["Hotel de Police",["Gavinies","A"]],
    ["Gavinies",["Stade Chaban Delmas","A"]],
    ["Stade Chaban Delmas",["Hopital Pellegrin","A"]],
    ["Hopital Pellegrin",["St Augustin","A"]],
    ["St Augustin",["Francois Mitterrand","A"]],
    ["Francois Mitterrand",["Peychotte","A"]],
    ["Peychotte",["Fontaine d'Arlac","A"]],
    ["Fontaine d'Arlac",["Alfred de Vigny","A"]],
    ["Alfred de Vigny",["Pierre Mendes France","A"]],
    ["Pierre Mendes France",["Quatre Chemins","A"]],
    ["Quatre Chemins",["Lycees de Merignac","A"]],
    ["Lycees de Merignac",["Merignac Centre","A"]],
        
# la ligne A1
    ["Palmer",["Pelletan","A1"]],
    ["Pelletan",["La Morlette","A1"]],
    ["La Morlette",["Jean Zay","A1"]],
    ["Jean Zay",["La Maregue","A1"]],
    ["La Maregue",["Floirac Dravemont","A1"]],    
# la ligne A2
    ["Iris",["Gravieres","A2"]],
    ["Gravieres",["Bois Fleuri","A2"]],
    ["Bois Fleuri",["Lormont Lauriers","A2"]]],
    "tram", [], 
    "rankdir = \"LR\"; ranksep = .1; ratio = .2; node[shape=box]; node[style=rounded];"
    )


tram_reduit = make_graph(
    [["Porte de Bourgogne",
      ["Quinconces","C"], ["Gare St Jean","C"],
      ["Hotel de ville","A"],["Butiniere","A"]],
     ["Hotel de ville",
      ["Bassins a Flot","B"],["Pessac Centre","B"],
      ["Merignac Centre","A"]],
     ["Butiniere",
      ["Floirac Dravemont","A1"], ["Lormont Lauriers","A2"]]],
    "tram_reduit")


graphes_concrets += [Konigsberg, tgv2005, Europe, tram, tram_reduit]

graphes += graphes_concrets

graphes_definis=[]

for g in graphes:
    graphes_definis.append(g.label)
    
print "\n\t\t====================\nPour afficher la liste des graphes definis, taper \tprint graphes_definis\n"
print "Pour afficher la description du graphe <nom>, taper \tafficher_graphe(<nom>)\n"
print "Pour afficher la dessin du graphe <nom>, taper \tdessiner_graphe(<nom>)\n\t\t====================\n"

def generer_liste_html(f, listegraphes):
    os.write(f,"<table>\n  <tr>\n    <td>\n      <ul>\n")
    for G in listegraphes:
        dessiner(G,'png')
        print nom_graphe(G) + "...",
        sys.stdout.flush()
        os.remove(nom_graphe(G) + ".dot")
        os.write(f,"        <li>\n")
        os.write(f,"                    <a href=\"./" + nom_graphe(G) + ".png\">")
        os.write(f,"<img src=\""  + nom_graphe(G) + ".png\"  title=\"" + nom_graphe(G) + "\" ")
        os.write(f, "alt=\"" + nom_graphe(G) +"\">")
        os.write(f,"</a>\n")
        os.write(f,"          <p>" + nom_graphe(G) + "</p>\n")    
        os.write(f,"        </li>\n")
    print ''
    os.write(f,"      </ul>\n    </td>\n  </tr>\n</table>\n\n")

def generer_bibliotheque_html():
    print "Generation de \"bibliotheque.html\" en cours dans le sous-repertoire \"html\""
    if not os.access("html",os.F_OK):
        os.mkdir("html")
    os.chdir("html")
    f = os.open("bibliotheque.html",os.O_CREAT|os.O_TRUNC|os.O_RDWR)
    os.write(f, '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">\n')
    os.write(f, '<html>\n')
    os.write(f, '<head>\n')
    os.write(f, '<meta http-equiv="Content-Type" content="text/html;charset=utf-8" >')
    os.write(f, '<title>Initiation &agrave; l\'informatique, biblioth&egrave;que de graphes</title>\n')
    os.write(f, '<link rel="StyleSheet" href="style.css" type="text/css" media="screen">')
    os.write(f, '</head>\n')
    os.write(f, '\n')
    os.write(f, '<body>\n\n')
    os.write(f, '<h1>Initiation &agrave; l\'informatique - Universit&eacute; Bordeaux 1 - 2007-2008<br/><br/> Biblioth&egrave;que de graphes</h1>\n\n')
    os.write(f, '<div style="text-align:center;margin:10px; color:#02b057;">Pour obtenir une image plus grande, cliquer sur la vignette.\n')
    os.write(f, '<br/>\n')
    os.write(f, '  Les noms affich&eacute;s sont ceux des variables dans lesquels les graphes sont m&eacute;moris&eacute;s.\n')
    os.write(f, '<br/>\n')
    os.write(f, '<hr>\n')
    os.write(f, '<a href="#concrets">Graphes concrets</a> - ')
    os.write(f, '<a href="#classiques">Graphes classiques</a> - ')
    os.write(f, '<a href="#complets">Complets</a> - ')
    os.write(f, '<a href="#bipartis">Bipartis complets</a> - ')
    os.write(f, '<a href="#arbres">Arbres</a> - ')
    os.write(f, '<a href="#grilles">Grilles</a> - ')
    os.write(f, '<a href="#lineaires">Lignes</a> - ')
    os.write(f, '<a href="#circulaires">Cercles</a> - ')
    os.write(f, '<a href="#divers">Graphes divers</a>')
    os.write(f, '</div>\n')

    os.write(f, '<a name="concrets"></a>')
    os.write(f, '<h2 style="border=0pt;">Graphes concrets</h2>\n')
    os.write(f, '\n')
    generer_liste_html(f, graphes_concrets)
    os.write(f, '<a name="classiques"></a>')
    os.write(f, '<h2 style="border=0pt;">Graphes classiques</h2>\n')
    os.write(f, '\n')
    generer_liste_html(f, [Petersen])
    os.write(f, '\n')
    os.write(f, '<h2>Familles de graphes</h2>\n')
    os.write(f, '\n')
    os.write(f, '<a name="complets"></a>')
    os.write(f, '<h3>Graphes complets &agrave; n sommets&nbsp;: <code>k(n)</code></h3>\n')
    generer_liste_html(f, graphes_complets)
    os.write(f, '\n')
    os.write(f, '<a name="bipartis"></a>')
    os.write(f, '<h3>Graphes bipartis complets (bicliques) nxm&nbsp;:  <code>biclique(n,m)</code></h3>\n')
    generer_liste_html(f, graphes_bicliques)
    os.write(f, '\n')
    os.write(f, '<a name="arbres"></a>')
    os.write(f, '<h3>Arbres, n sommets, hauteur h&nbsp;: <code>arbre(n,h)</code></h3>\n')
    generer_liste_html(f, arbres)
    os.write(f, '\n')
    os.write(f, '<a name="grilles"></a>')
    os.write(f, '<h3>Grilles, nxm&nbsp;: <code>grille(n,m)</code></h3>\n')
    generer_liste_html(f, grilles)
    os.write(f, '<a name="lineaires"></a>')
    os.write(f, '<h3>Graphes lin&eacute;aires &agrave; n sommets&nbsp;: <code>lin(n)</code></h3>\n')
    generer_liste_html(f, graphes_lineaires)
    os.write(f, '\n')
    os.write(f, '<a name="circulaires"></a>')
    os.write(f, '<h3>Graphes circulaires  &agrave; n sommets&nbsp;: <code>cercle(n)</code></h3>\n')
    generer_liste_html(f, graphes_circulaires)
    os.write(f, '\n')
    os.write(f, '<a name="divers"></a>')
    os.write(f, '<h2>Graphes divers</h2>\n')
    generer_liste_html(f, graphes_divers)
    os.write(f, '\n')
    os.write(f, '<BR>\n')
    os.write(f,"</body>\n</html>\n")             
    os.close(f)
    os.chdir("..")
